!include "..\Common.nsh"

;-----------------------------------------------------------------------
; MAIN SCRIPT

SetCompressor /SOLID lzma

!include "MUI.nsh"

Name "JSPacker"
OutFile "JSPacker_v1.0.exe"

InstallDir "$PROGRAMFILES\Arnapou\JSPacker"
InstallDirRegKey HKCU "Software\Arnapou\JSPacker" ""

!define MUI_ABORTWARNING

;!insertmacro MUI_PAGE_LICENSE "licence.txt"
;!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

!insertmacro MUI_LANGUAGE "English" ;first language is the default language
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Portuguese"

InstType "Normal"

Section "Programmes" Sec_Program
	SectionIn 1 RO
	SetOutPath $INSTDIR
	File "JSPacker.exe"
	SetShellVarContext current
	CreateDirectory "$SMPROGRAMS\Arnapou"
	CreateDirectory "$SMPROGRAMS\Arnapou\JSPacker"
	CreateShortCut "$SMPROGRAMS\Arnapou\JSPacker\JSPacker.lnk" "$INSTDIR\JSPacker.exe"
SectionEnd

Section -PostInstall Sec_PostInstall
	WriteUninstaller "$INSTDIR\uninstall.exe"
	WriteRegStr HKCU "Software\Arnapou\JSPacker" "" '"$INSTDIR"'
	CreateShortCut "$SMPROGRAMS\Arnapou\JSPacker\Uninstall.lnk" "$INSTDIR\uninstall.exe"
	SetShellVarContext current
	!insertmacro AddRemovePanel_ADD "Arnapou / JSPacker" "1.0" "650" "$INSTDIR\uninstall.exe"
SectionEnd 

UninstallText "Uninstall Arnapou JSPacker ?"

Section "Uninstall" Sec_Uninstall	
	SetOutPath $TEMP
	DetailPrint "JSPacker est install  : $INSTDIR"
	RMDir /r /REBOOTOK "$INSTDIR"
	SetShellVarContext current
	RMDir /r "$SMPROGRAMS\Arnapou\JSPacker"
	
	!insertmacro AddRemovePanel_REMOVE "Arnapou / JSPacker"
SectionEnd 
