unit TJSPacker;

interface

uses Classes, VBScriptRegex;

type
  TPackerEncoding = (None, Numeric, Normal, HighASCII);
  //- - - - - - - - - - - - - - - - - - - - - - - - - - -
  Packer = class
  private
    nEncoding : integer;
    procedure basicCompression;
    procedure encodeSpecialChars;
    procedure encodeKeywords;
  public
    Encoding : TPackerEncoding;
    FastDecode : boolean;
    SpecialCharacters : boolean;
    Size : integer;
    NewSize : integer;
    Ratio : double;
    Script : string;
    PackedScript : string;
    constructor Create;
    procedure Pack;
  end;          
  //- - - - - - - - - - - - - - - - - - - - - - - - - - -
  ParseMaster = class
  private
	  const EXPRESSION = 0;
	  const REPLACEMENT = 1;
	  const LENGTH = 2;
	  GROUPS : string;
	  SUB_REPLACE : string;
	  INDEXED : string;
	  TRIM : string;
	  ESCAPE : string;
	  QUOTE : string;
	  DELETED : string;
  public
    ignoreCase : boolean;
    escapeChar : string;
    constructor Create();
  end;
  //- - - - - - - - - - - - - - - - - - - - - - - - - - -

implementation 
//--------------------------------------------------------
constructor ParseMaster.Create;
begin
  ignoreCase := False;
  escapeChar := '';   
  GROUPS := '\(';//g
	SUB_REPLACE := '\$\d';
	INDEXED := '^\$\d+$';
	TRIM := '([''"])\1\.(.*)\.\1\1$';
	ESCAPE := '\.';//g
	QUOTE := '''';
	DELETED := '\'+#01+'[^\'+#01+']*\'+#01;//g
end;
//--------------------------------------------------------
procedure Packer.basicCompression();
begin
  //
end;
//--------------------------------------------------------
procedure Packer.encodeSpecialChars();
begin
  //
end;
//--------------------------------------------------------
procedure Packer.encodeKeywords();
begin
  //
end;
//--------------------------------------------------------
constructor Packer.Create;
begin
  Encoding := Normal;
  FastDecode := True;
  SpecialCharacters := False;
end;
//--------------------------------------------------------
procedure Packer.Pack;
begin
  // init
  case Encoding of
    None     : nEncoding := 0;
    Numeric  : nEncoding := 10;
    Normal   : nEncoding := 62;
    HighASCII: nEncoding := 95;
  end;
  Size := Length(Script);
  PackedScript := Script;
  // packing
  basicCompression;
  if SpecialCharacters then encodeSpecialChars;
  if nEncoding > 0 then encodeKeywords;
  // ending
  NewSize := Length(PackedScript);
  Ratio := NewSize/Size;
end;

end.
