unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Filectrl,
  RunProcess, VBScriptRegex, pack_wsf, Common, Environment,
  process;

type
  TForm1 = class(TForm)
    pgControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    btnQuitter: TButton;
    Panel2: TPanel;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    btnPack: TButton;
    rchText: TRichEdit;
    rchResult: TRichEdit;
    Panel5: TPanel;
    Label3: TLabel;
    lstEncode: TComboBox;
    chkFastDecode: TCheckBox;
    chkSpecialChars: TCheckBox;
    Panel6: TPanel;
    lblStatus: TLabel;
    Panel7: TPanel;
    btnFolderIn: TButton;
    edtFolderIn: TEdit;
    lstFiles: TFileListBox;
    Label4: TLabel;
    Panel8: TPanel;
    btnSELAll: TButton;
    btnSELNone: TButton;
    btnSELInvert: TButton;
    Panel9: TPanel;
    Panel10: TPanel;
    btnRefresh: TButton;
    procedure btnQuitterClick(Sender: TObject);
    procedure btnPackClick(Sender: TObject);
    procedure TabSheet1Resize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetResult(Sender : TObject); 
    procedure SelectFile(Index: integer; Selected:boolean);
    procedure FormDestroy(Sender: TObject);
    procedure btnFolderInClick(Sender: TObject);
    procedure edtFolderInChange(Sender: TObject);
    procedure lstFilesChange(Sender: TObject);
    procedure btnSELNoneClick(Sender: TObject);
    procedure btnSELAllClick(Sender: TObject);
    procedure btnSELInvertClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
  private
    { Dclarations prives }
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  R: TRunProcess;

//-----------------------------------------------------------------
procedure TForm1.SelectFile(Index: integer; Selected:boolean);
var
  re: IRegex;
begin
  re := VBScriptRegex.Regex.Create('-packed\.js$', [reIgnoreCase]);
  if Selected then begin
    if re.Match(lstFiles.Items[Index]) then
      lstFiles.Selected[Index] := False
    else
      lstFiles.Selected[Index] := True
  end else
    lstFiles.Selected[Index] := False;
end;
//-----------------------------------------------------------------
procedure TForm1.GetResult(Sender : TObject);
begin
  rchResult.Text := '';
  rchResult.Text := TStd(Sender).Datas;
  lblStatus.Caption := IntToStr(Length(rchResult.Text))+' / '+
    IntToStr(Length(rchText.Text))+'    '+
    IntToStr(Round(100*Length(rchResult.Text)/Length(rchText.Text)))+'%';
end;                         
//-----------------------------------------------------------------
procedure TForm1.lstFilesChange(Sender: TObject);
var
  re: IRegex;
  i: Integer;
begin
  re := VBScriptRegex.Regex.Create('-packed\.js$', [reIgnoreCase]);
  for i := 0 to lstFiles.Items.Count - 1 do
    if re.Match(lstFiles.Items[i]) then
      SelectFile(i, False);
end;
//-----------------------------------------------------------------
procedure TForm1.btnFolderInClick(Sender: TObject);
var
  sFolder: string;
begin
  sFolder := edtFolderIn.Text;
  if SelectDirectory('Slectionnez un dossier:', '', sFolder) then
       if sFolder<> '' then
           edtFolderIn.Text := sFolder;
end;
//-----------------------------------------------------------------
procedure TForm1.btnPackClick(Sender: TObject);
var
  i, N :integer;
begin
  case (pgControl.ActivePageIndex) of
    0: begin
      if Length(rchText.Text)>0 then begin
      CreateJS(rchText.Text);
      rchResult.Text := 'Please wait !'+CRLF+CRLF+'Running ...';
      lblStatus.Caption := '';
      R := TRunProcess.Create;
      R.StdOut.Enabled := True;
      R.StdOut.OnEnd := GetResult;
      R.WindowStyle := wHide;
      R.Commands.Add(getCMD(
        JSFileName,
        lstEncode.ItemIndex,
        chkFastDecode.checked,
        chkSpecialChars.checked));
      R.RunThread;
      end;
    end;
    1: begin
      Form2.Files := TStringList.create;
      Form2.EncodeIndex := lstEncode.ItemIndex;
      Form2.FastDecode := chkFastDecode.checked;
      Form2.SpecialChars := chkSpecialChars.checked;
      N := 0;
      for i := 0 to lstFiles.Items.Count - 1 do begin
        if lstFiles.Selected[i] then begin
          Form2.Files.Add(GetDirSlash(edtFolderIn.Text)+lstFiles.Items[i]);
          N := N + 1;
        end;
      end;
      if DirectoryExists(edtFolderIn.Text) then begin
        if N > 0 then
          Form2.ShowModal
        else
          ShowMessage('Select file(s) to process');
        end
      else
        ShowMessage('The folder does''nt exists');
    end;
  end;
end;
//-----------------------------------------------------------------
procedure TForm1.btnQuitterClick(Sender: TObject);
begin
  Self.Close;
end;
//-----------------------------------------------------------------
procedure TForm1.btnRefreshClick(Sender: TObject);
begin
  lstFiles.Refresh;
end;
//-----------------------------------------------------------------
procedure TForm1.btnSELAllClick(Sender: TObject);
var i :integer;
begin
  for I := 0 to lstFiles.Items.Count - 1 do
    SelectFile(i, True);
end;
//-----------------------------------------------------------------
procedure TForm1.btnSELInvertClick(Sender: TObject);
var i :integer;
begin
  for I := 0 to lstFiles.Items.Count - 1 do
    SelectFile(i, Not(lstFiles.Selected[i]));
end;
//-----------------------------------------------------------------
procedure TForm1.btnSELNoneClick(Sender: TObject);
var i :integer;
begin
  for I := 0 to lstFiles.Items.Count - 1 do
    SelectFile(i, False);
end;
//-----------------------------------------------------------------
procedure TForm1.edtFolderInChange(Sender: TObject);
begin
     if DirectoryExists(edtFolderIn.Text) then
     begin
        lstFiles.Directory := edtFolderIn.Text;
        lstFiles.Font.Color := clWindowText;
        edtFolderIn.Font.Color := clWindowText;
     end
     else
     begin
        lstFiles.Font.Color := clRed;
        edtFolderIn.Font.Color := clRed;
     end;
end;
//-----------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  TabSheet1Resize(TabSheet1);
  CreateWSF;
  edtFolderIn.Text := GetCurrentDir;
  lstFiles.Directory := GetCurrentDir;
end;
//-----------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(R) then
    if R.IsRunning then R.Terminate;
end;
//-----------------------------------------------------------------
procedure TForm1.TabSheet1Resize(Sender: TObject);
begin
  Panel4.Height := (TabSheet1.Height-Panel6.Height) div 2;
end;

end.
