unit process;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,
  RunProcess, pack_wsf, common;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    btnCancel: TButton;
    btnClose: TButton;
    lblStatus: TLabel;
    lstFiles: TListBox;
    Progress: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure ProcEnd(Sender: TObject);   
    procedure Test(Sender: TObject);
  private
    R : TRunProcess;
    Canceled : boolean;
    MaxSize : integer;
  public
    Files : TStringList;
    EncodeIndex : integer;
    FastDecode, SpecialChars : boolean;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}
              
//----------------------------------------------------
procedure TForm2.btnCancelClick(Sender: TObject);
begin                             
  Canceled := True;
  if Assigned(R) then R.Terminate;
  lstFiles.Items[Progress.Position] := BaseName(Files[Progress.Position])+'    CANCELED ...';
  btnCancel.Visible := false;
  btnClose.Visible := true;
end;
//----------------------------------------------------
procedure TForm2.btnCloseClick(Sender: TObject);
begin
  Form2.Close;
end;
//----------------------------------------------------
procedure TForm2.FormCreate(Sender: TObject);
begin
end;
//----------------------------------------------------
procedure TForm2.FormShow(Sender: TObject);
var i:integer;
begin
  btnClose.Visible:= false;
  btnCancel.Visible := true;
  Canceled := False;
  Progress.Max := Files.Count;
  Progress.Position := 0;
  lstFiles.Clear;
  R := TRunProcess.Create;
  R.WindowStyle := wHide;
  R.StdOut.Enabled := True;
  R.StdOut.OnEnd := ProcEnd;
//  R.StdOut.OnInputLine := Test;
  MaxSize := 0;
  for i := 0 to Files.Count - 1 do begin
    R.Commands.Add(getCmd(Files[i], EncodeIndex, FastDecode, SpecialChars));
    lstFiles.AddItem(BaseName(Files[i]), nil);
    if length(BaseName(Files[i])) > MaxSize then
      MaxSize := length(BaseName(Files[i]));
  end;
  MaxSize := MaxSize + 4;
  lstFiles.Selected[0] := True;
  lstFiles.Items[0] := StrPadRight(BaseName(Files[0]), MaxSize)+'PROCESSING ...';
  R.RunThread;
end;      
//----------------------------------------------------
procedure TForm2.Test(Sender: TObject);
begin
  showmessage(TStd(Sender).Line);
end;
//----------------------------------------------------
procedure TForm2.ProcEnd(Sender: TObject);
var
  i, N1, N2: integer;
  Datas : string;
begin
  if Not(Canceled) then begin
    i := Progress.Position;
    Datas := TStd(Sender).Datas;
    N1 := Length(getFileContent(Files[i]));
    N2 := Length(Datas);
    lstFiles.Items[i] := StrPadRight(BaseName(Files[i]), MaxSize)+
      'DONE.  '+
      StrPadLeft(N2, 8) + '/'+StrPadRight(N1, 8) + ' (' +
      IntToStr(Round(100*N2/N1)) + '%)';
    setFileContent(
      LeftStr(Files[i], Length(Files[i])-3)+'-packed.js',
      Datas);
    Progress.Position := i + 1;
    if (i < Files.Count-1) then begin
      lstFiles.Selected[i+1] := True;
      lstFiles.Items[i+1] := StrPadRight(BaseName(Files[i+1]), MaxSize)+
        'PROCESSING ...';
    end else begin
      lstFiles.Selected[lstFiles.Items.Count-1] := False;
      btnCancel.Visible := false;
      btnClose.Visible := true;
    end;
  end;
end;
//----------------------------------------------------

end.
